/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of RPM2.xs. Do not edit this file, edit RPM2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "RPM2.xs"
#include <stdio.h>
#include <string.h>
#include <rpmlib.h>
#include <rpmcli.h>

#ifndef RPM2_RPM40
#  include <rpmts.h>
#  include <rpmte.h>
#endif

#include <header.h>
#include <rpmdb.h>
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
#  include "misc.h"
#else
#  define _RPM_4_4_COMPAT
#  include <rpmlegacy.h>
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#if !defined(RPM2_RPM41) && !defined(RPM2_RPM40) && !defined(RPM2_RPM46)
#error Seems like Makefile.PL could not guess your RPM API version.
#endif

/* Chip, this is somewhat stripped down from the default callback used by
   the rpmcli.  It has to be here to insure that we open the pkg again. 
   If we don't do this we get segfaults.  I also, kept the updating of some
   of the rpmcli static vars, but I may not have needed to do this.

   Also, we probably want to give a nice interface such that we could allow
   users of RPM2 to do their own callback, but that will have to come later.
*/
void * _null_callback(
	const void * arg, 
	const rpmCallbackType what,
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
	const unsigned long amount, 
	const unsigned long total,
#else 
	const rpm_loff_t amount,
	const rpm_loff_t total,
#endif
	fnpyKey key, 
	rpmCallbackData data)
{
	Header h = (Header) arg;
	char * s;
	int flags = (int) ((long)data);
	void * rc = NULL;
	const char * filename = (const char *)key;
	static FD_t fd = NULL;
	int xx;

	/* Code stolen from rpminstall.c and modified */
	switch(what) {
		case RPMCALLBACK_INST_OPEN_FILE:
	 		if (filename == NULL || filename[0] == '\0')
			     return NULL;
			fd = Fopen(filename, "r.ufdio");
			/* FIX: still necessary? */
			if (fd == NULL || Ferror(fd)) {
				fprintf(stderr, "open of %s failed!\n", filename);
				if (fd != NULL) {
					xx = Fclose(fd);
					fd = NULL;
				}
			} else
				fd = fdLink(fd, "persist (showProgress)");
			return (void *)fd;
	 		break;

	case RPMCALLBACK_INST_CLOSE_FILE:
		/* FIX: still necessary? */
		fd = fdFree(fd, "persist (showProgress)");
		if (fd != NULL) {
			xx = Fclose(fd);
			fd = NULL;
		}
		break;

	case RPMCALLBACK_INST_START:
		rpmcliHashesCurrent = 0;
		if (h == NULL || !(flags & INSTALL_LABEL))
			break;
		break;

	case RPMCALLBACK_TRANS_PROGRESS:
	case RPMCALLBACK_INST_PROGRESS:
		break;

	case RPMCALLBACK_TRANS_START:
		rpmcliHashesCurrent = 0;
		rpmcliProgressTotal = 1;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_TRANS_STOP:
		rpmcliProgressTotal = rpmcliPackagesTotal;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_REPACKAGE_START:
		rpmcliHashesCurrent = 0;
		rpmcliProgressTotal = total;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_REPACKAGE_PROGRESS:
		break;

	case RPMCALLBACK_REPACKAGE_STOP:
		rpmcliProgressTotal = total;
		rpmcliProgressCurrent = total;
		rpmcliProgressTotal = rpmcliPackagesTotal;
		rpmcliProgressCurrent = 0;
		break;

	case RPMCALLBACK_UNINST_PROGRESS:
		break;
	case RPMCALLBACK_UNINST_START:
		break;
	case RPMCALLBACK_UNINST_STOP:
		break;
	case RPMCALLBACK_UNPACK_ERROR:
		break;
	case RPMCALLBACK_CPIO_ERROR:
		break;
	case RPMCALLBACK_UNKNOWN:
		break;
	default:
		break;
	}
	
	return rc;	
}

void
_populate_header_tags(HV *href)
{
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
    int i = 0;

    for (i = 0; i < rpmTagTableSize; i++) {
        hv_store(href, rpmTagTable[i].name, strlen(rpmTagTable[i].name), newSViv(rpmTagTable[i].val), 0);
    }
#else
    rpmtd names;
    const char *name;

    names = rpmtdNew();
    rpmTagGetNames(names, 1);
    while ((name = rpmtdNextString(names)) != NULL) {
        const char *sname = name + strlen("RPMTAG_");
        hv_store(href, name, strlen(name),
            newSViv(rpmTagGetValue(name + strlen("RPMTAG_"))), 0);
    }
#endif
}

void
_populate_constant(HV *href, char *name, int val)
{
    hv_store(href, name, strlen(name), newSViv(val), 0);
}

#define REGISTER_CONSTANT(name) _populate_constant(constants, #name, name)

#line 181 "RPM2.c"

XS(XS_RPM2_rpm_api_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_rpm_api_version)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::rpm_api_version(pkg)");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	double	RETVAL;
	dXSTARG;
#line 210 "RPM2.xs"
#ifdef RPM2_RPM46
	RETVAL = (double)4.6;
#endif
#ifdef RPM2_RPM41
	RETVAL = (double)4.1;
#endif
#ifdef RPM2_RPM40
	RETVAL = (double)4.0;
#endif
#line 203 "RPM2.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2_add_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_add_macro)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: RPM2::add_macro(pkg, name, val)");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	char *	val = (char *)SvPV_nolen(ST(2));
#line 229 "RPM2.xs"
	addMacro(NULL, name, NULL, val, RMIL_DEFAULT);
#line 222 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2_delete_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_delete_macro)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::delete_macro(pkg, name)");
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
#line 236 "RPM2.xs"
	delMacro(NULL, name);
#line 239 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2_expand_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_expand_macro)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::expand_macro(pkg, str)");
    SP -= items;
    {
	char *	pkg = (char *)SvPV_nolen(ST(0));
	char *	str = (char *)SvPV_nolen(ST(1));
#line 243 "RPM2.xs"
	char *ret;
#line 257 "RPM2.c"
#line 245 "RPM2.xs"
	ret = rpmExpand(str, NULL);
	PUSHs(sv_2mortal(newSVpv(ret, 0)));
	free(ret);
#line 262 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2_rpmvercmp)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::rpmvercmp(one, two)");
    {
	char*	one = (char *)SvPV_nolen(ST(0));
	char*	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__read_package_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__read_package_info)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::_read_package_info(fp, vsflags)");
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
	int	vsflags = (int)SvIV(ST(1));
#line 259 "RPM2.xs"
#ifndef RPM2_RPM40
	rpmts ts;
#endif
	Header ret;
	Header sigs;
	rpmRC rc;
	FD_t fd;
#line 306 "RPM2.c"
#line 267 "RPM2.xs"
#ifndef RPM2_RPM40
	ts = rpmtsCreate();
#endif

        /* XXX Determine type of signature verification when reading
	vsflags |= _RPMTS_VSF_NOLEGACY;
	vsflags |= _RPMTS_VSF_NODIGESTS;
	vsflags |= _RPMTS_VSF_NOSIGNATURES;
	xx = rpmtsSetVerifySigFlags(ts, vsflags);
        */ 

	fd = fdDup(fileno(fp));
#ifndef RPM2_RPM40
	rpmtsSetVSFlags(ts, vsflags);
	rc = rpmReadPackageFile(ts, fd, "filename or other identifier", &ret);
#else
	rc = rpmReadPackageInfo(fd, NULL, &ret);
#endif

	Fclose(fd);

	if (rc == RPMRC_OK) {
	    SV *h_sv;

	    EXTEND(SP, 1);

	    h_sv = sv_newmortal();
            sv_setref_pv(h_sv, "RPM2::C::Header", (void *)ret);

	    PUSHs(h_sv);
	}
	else {
	    croak("error reading package");
	}
#ifndef RPM2_RPM40
	ts = rpmtsFree(ts);
#endif
#line 345 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__create_transaction); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__create_transaction)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::_create_transaction(vsflags)");
    SP -= items;
    {
	int	vsflags = (int)SvIV(ST(0));
#line 309 "RPM2.xs"
	rpmts ret;
	SV *h_sv;
#line 364 "RPM2.c"
#line 312 "RPM2.xs"
	/* Looking at librpm, it does not look like this ever
	   returns error (though maybe it should).
	*/
	ret = rpmtsCreate();

	/* Should I save the old vsflags aside? */
	rpmtsSetVSFlags(ret, vsflags);

	/* Convert and throw the results on the stack */	
	EXTEND(SP, 1);

	h_sv = sv_newmortal();
	sv_setref_pv(h_sv, "RPM2::C::Transaction", (void *)ret);

	PUSHs(h_sv);
#line 381 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__read_from_file); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__read_from_file)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::_read_from_file(fp)");
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
#line 332 "RPM2.xs"
	SV *h_sv;
	FD_t fd;
	Header h;
#line 401 "RPM2.c"
#line 336 "RPM2.xs"
	fd = fdDup(fileno(fp));
	h = headerRead(fd, HEADER_MAGIC_YES);

	if (h) {
	    EXTEND(SP, 1);

	    h_sv = sv_newmortal();
	    sv_setref_pv(h_sv, "RPM2::C::Header", (void *)h);

	    PUSHs(h_sv);
	}
	Fclose(fd);
#line 415 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__open_rpm_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__open_rpm_db)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::_open_rpm_db(for_write)");
    {
	int	for_write = (int)SvIV(ST(0));
#line 354 "RPM2.xs"
	 rpmdb db;
#line 432 "RPM2.c"
	rpmdb	RETVAL;
#line 356 "RPM2.xs"
	if (rpmdbOpen(NULL, &db, for_write ? O_RDWR | O_CREAT : O_RDONLY, 0644)) {
		croak("rpmdbOpen failed");
		RETVAL = NULL;
	}
	RETVAL = db;		
#line 440 "RPM2.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "RPM2::C::DB", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::DB::DESTROY(db)");
    {
	rpmdb	db;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        db = (rpmdb)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::DESTROY() -- db is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 370 "RPM2.xs"
	rpmdbClose(db);
#line 465 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__DB__close_rpm_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB__close_rpm_db)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::DB::_close_rpm_db(self)");
    {
	rpmdb	self;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        self = (rpmdb)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::_close_rpm_db() -- self is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 376 "RPM2.xs"
	rpmdbClose(self);
#line 488 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__DB__init_iterator); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__DB__init_iterator)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: RPM2::C::DB::_init_iterator(db, rpmtag, key, len)");
    {
	rpmdb	db;
	int	rpmtag = (int)SvIV(ST(1));
	char *	key = (char *)SvPV_nolen(ST(2));
	size_t	len = (size_t)SvUV(ST(3));
	rpmdbMatchIterator	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        db = (rpmdb)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::DB::_init_iterator() -- db is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 385 "RPM2.xs"
    /* See rpmdbInitIterator() code for explanation of this */
	if (rpmtag == RPMDBI_PACKAGES) {
		len = sizeof (key);
	}

	RETVAL = rpmdbInitIterator(db, rpmtag, key && *key ? key : NULL, len);
#line 520 "RPM2.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "RPM2::C::PackageIterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__PackageIterator__iterator_next); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__PackageIterator__iterator_next)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::PackageIterator::_iterator_next(i)");
    SP -= items;
    {
	rpmdbMatchIterator	i;
#line 399 "RPM2.xs"
	Header       ret;
        SV *         h_sv;
	unsigned int offset;
#line 541 "RPM2.c"
	Header	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        i = (rpmdbMatchIterator)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::PackageIterator::_iterator_next() -- i is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 403 "RPM2.xs"
	ret = rpmdbNextIterator(i);
	if (ret)
		headerLink(ret);
	if(ret != NULL) 
		offset = rpmdbGetIteratorOffset(i);
	else
		offset = 0;

	EXTEND(SP, 2);
	h_sv = sv_newmortal();
	sv_setref_pv(h_sv, "RPM2::C::Header", (void *)ret);
	PUSHs(h_sv);
	PUSHs(sv_2mortal(newSViv(offset)));
#line 564 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__PackageIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__PackageIterator_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::PackageIterator::DESTROY(i)");
    {
	rpmdbMatchIterator	i;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        i = (rpmdbMatchIterator)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::PackageIterator::DESTROY() -- i is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 421 "RPM2.xs"
	rpmdbFreeIterator(i);
#line 588 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Header_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Header::DESTROY(h)");
    {
	Header	h;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::DESTROY() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 430 "RPM2.xs"
	headerFree(h);
#line 611 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Header_tag_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header_tag_by_id)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::C::Header::tag_by_id(h, tag)");
    SP -= items;
    {
	Header	h;
	int	tag = (int)SvIV(ST(1));
#line 437 "RPM2.xs"
	void *ret = NULL;
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
	int type;
#else
	rpmTagType type;
#endif
	int n;
	int ok;
#line 636 "RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::tag_by_id() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 446 "RPM2.xs"
	ok = headerGetEntry(h, tag, &type, &ret, &n);

	if (!ok) {
		/* nop, empty stack */
	}
	else {
		switch(type)
		{
		case RPM_STRING_ARRAY_TYPE:
			{
			int i;
			char **s;

			EXTEND(SP, n);
			s = (char **)ret;

			for (i = 0; i < n; i++) {
				PUSHs(sv_2mortal(newSVpv(s[i], 0)));
			}
			}
			break;
		case RPM_STRING_TYPE:
			PUSHs(sv_2mortal(newSVpv((char *)ret, 0)));
			break;
		case RPM_CHAR_TYPE:
			{
			int i;
			char *r;

			EXTEND(SP, n);
			r = (char *)ret;

			for (i = 0; i < n; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT8_TYPE:
			{
			int i;
			uint8_t *r;

			EXTEND(SP, n);
			r = (uint8_t *)ret;

			for (i = 0; i < n; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT16_TYPE:
			{
			int i;
			uint16_t *r;

			EXTEND(SP, n);
			r = (uint16_t *)ret;

			for (i = 0; i < n; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		case RPM_INT32_TYPE:
			{
			int i;
			uint32_t *r;

			EXTEND(SP, n);
			r = (uint32_t *)ret;

			for (i = 0; i < n; i++) {
				PUSHs(sv_2mortal(newSViv(r[i])));
			}
			}
			break;
		default:
			croak("unknown rpm tag type %d", type);
		}
	}
	headerFreeData(ret, type);
#line 726 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Header__header_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_compare)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::C::Header::_header_compare(h1, h2)");
    {
	Header	h1;
	Header	h2;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h1 = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_compare() -- h1 is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h2 = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Header::_header_compare() -- h2 is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 533 "RPM2.xs"
	RETVAL = rpmVersionCompare(h1, h2);
#line 760 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Header__header_is_source); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_is_source)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Header::_header_is_source(h)");
    {
	Header	h;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_is_source() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 541 "RPM2.xs"
	RETVAL = headerIsEntry(h, RPMTAG_SOURCEPACKAGE);
#line 786 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Header__header_sprintf); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Header__header_sprintf)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::C::Header::_header_sprintf(h, format)");
    SP -= items;
    {
	Header	h;
	char *	format = (char *)SvPV_nolen(ST(1));
#line 550 "RPM2.xs"
	char * s;
#line 805 "RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Header::_header_sprintf() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 552 "RPM2.xs"
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
	s =  headerSprintf(h, format, rpmTagTable, rpmHeaderFormats, NULL);
#else
	s =  headerFormat(h, format, NULL);
#endif
	PUSHs(sv_2mortal(newSVpv((char *)s, 0)));
/* By the way, the #if below is completely useless, free() would work for both */
#if defined(RPM2_RPM40) || defined(RPM2_RPM41)
	s = _free(s);
#else
	free(s);
#endif
#line 826 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::DESTROY(t)");
    {
	rpmts	t;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::DESTROY() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 572 "RPM2.xs"
	t = rpmtsFree(t);
#line 850 "RPM2.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_RPM2__C__Transaction__add_install); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__add_install)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_add_install(t, h, fn, upgrade)");
    {
	rpmts	t;
	Header	h;
	char *	fn = (char *)SvPV_nolen(ST(2));
	int	upgrade = (int)SvIV(ST(3));
#line 582 "RPM2.xs"
	rpmRC rc = 0;
#line 869 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_add_install() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Transaction::_add_install() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 584 "RPM2.xs"
	rc = rpmtsAddInstallElement(t, h, (fnpyKey) fn, upgrade, NULL);
	RETVAL = (rc == RPMRC_OK) ? 1 : 0;
#line 889 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__add_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__add_delete)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_add_delete(t, h, offset)");
    {
	rpmts	t;
	Header	h;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
#line 595 "RPM2.xs"
	rpmRC rc = 0;
#line 908 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_add_delete() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        h = (Header)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "RPM2::C::Transaction::_add_delete() -- h is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 597 "RPM2.xs"
	rc = rpmtsAddEraseElement(t, h, offset);
	RETVAL = (rc == RPMRC_OK) ? 1 : 0;
#line 928 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__element_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__element_count)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_element_count(t)");
    {
	rpmts	t;
#line 606 "RPM2.xs"
	int ret;
#line 945 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_element_count() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 608 "RPM2.xs"
	ret    = rpmtsNElements(t);
	RETVAL = ret;
#line 958 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__close_db); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__close_db)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_close_db(t)");
    {
	rpmts	t;
#line 617 "RPM2.xs"
	int ret;
#line 975 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_close_db() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 619 "RPM2.xs"
	ret    = rpmtsCloseDB(t);
	RETVAL = (ret == 0) ? 1 : 0;
#line 988 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__check); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__check)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_check(t)");
    {
	rpmts	t;
#line 628 "RPM2.xs"
	int ret;
#line 1005 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_check() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 630 "RPM2.xs"
	ret    = rpmtsCheck(t);
	RETVAL = (ret == 0) ? 1 : 0;
#line 1018 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__order); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__order)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_order(t)");
    {
	rpmts	t;
#line 639 "RPM2.xs"
	int ret;
#line 1035 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_order() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 641 "RPM2.xs"
	ret    = rpmtsOrder(t);
	/* XXX:  May want to do something different here.  It actually
	         returns the number of non-ordered elements...maybe we
	         want this?
	*/
	RETVAL = (ret == 0) ? 1 : 0;
#line 1052 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_RPM2__C__Transaction__elements); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__elements)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_elements(t, type)");
    SP -= items;
    {
	rpmts	t;
	rpmElementType	type = (rpmElementType)SvIV(ST(1));
#line 655 "RPM2.xs"
	rpmtsi       i;
	rpmte        te;
	const char * NEVR;
#line 1073 "RPM2.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_elements() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 659 "RPM2.xs"
	i = rpmtsiInit(t);
	if(i == NULL) {
		printf("Did not get a thing!\n");
		return;	
	} else {
		while((te = rpmtsiNext(i, type)) != NULL) {
			NEVR = rpmteNEVR(te);
			XPUSHs(sv_2mortal(newSVpv(NEVR,	0)));
		}
		i = rpmtsiFree(i);
	}
#line 1093 "RPM2.c"
	PUTBACK;
	return;
    }
}


XS(XS_RPM2__C__Transaction__run); /* prototype to pass -Wmissing-prototypes */
XS(XS_RPM2__C__Transaction__run)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: RPM2::C::Transaction::_run(t, ok_probs, prob_filter)");
    {
	rpmts	t;
	rpmprobFilterFlags	prob_filter = (rpmprobFilterFlags)SvIV(ST(2));
#line 676 "RPM2.xs"
	int i;
	rpmProblem p;
	int ret;
#line 1113 "RPM2.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        t = (rpmts)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "RPM2::C::Transaction::_run() -- t is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 680 "RPM2.xs"
	/* Make sure we could run this transactions */
	ret = rpmtsCheck(t);
	if (ret != 0) {
		RETVAL = 0;
		return;
	}
	ret = rpmtsOrder(t);
	if (ret != 0) {
		RETVAL = 0;
		return;
	}

	/* XXX:  Should support callbacks eventually */
	(void) rpmtsSetNotifyCallback(t, _null_callback, (void *) ((long)0));
	ret    = rpmtsRun(t, NULL, prob_filter);
	RETVAL = (ret == 0) ? 1 : 0;
#line 1140 "RPM2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_RPM2); /* prototype to pass -Wmissing-prototypes */
XS(boot_RPM2)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("RPM2::rpm_api_version", XS_RPM2_rpm_api_version, file, "$");
        newXSproto("RPM2::add_macro", XS_RPM2_add_macro, file, "$$$");
        newXSproto("RPM2::delete_macro", XS_RPM2_delete_macro, file, "$$");
        newXSproto("RPM2::expand_macro", XS_RPM2_expand_macro, file, "$$");
        newXSproto("RPM2::rpmvercmp", XS_RPM2_rpmvercmp, file, "$$");
        newXSproto("RPM2::_read_package_info", XS_RPM2__read_package_info, file, "$$");
        newXSproto("RPM2::_create_transaction", XS_RPM2__create_transaction, file, "$");
        newXSproto("RPM2::_read_from_file", XS_RPM2__read_from_file, file, "$");
        newXSproto("RPM2::_open_rpm_db", XS_RPM2__open_rpm_db, file, "$");
        newXSproto("RPM2::C::DB::DESTROY", XS_RPM2__C__DB_DESTROY, file, "$");
        newXSproto("RPM2::C::DB::_close_rpm_db", XS_RPM2__C__DB__close_rpm_db, file, "$");
        newXSproto("RPM2::C::DB::_init_iterator", XS_RPM2__C__DB__init_iterator, file, "$$$$");
        newXSproto("RPM2::C::PackageIterator::_iterator_next", XS_RPM2__C__PackageIterator__iterator_next, file, "$");
        newXSproto("RPM2::C::PackageIterator::DESTROY", XS_RPM2__C__PackageIterator_DESTROY, file, "$");
        newXSproto("RPM2::C::Header::DESTROY", XS_RPM2__C__Header_DESTROY, file, "$");
        newXSproto("RPM2::C::Header::tag_by_id", XS_RPM2__C__Header_tag_by_id, file, "$$");
        newXSproto("RPM2::C::Header::_header_compare", XS_RPM2__C__Header__header_compare, file, "$$");
        newXSproto("RPM2::C::Header::_header_is_source", XS_RPM2__C__Header__header_is_source, file, "$");
        newXSproto("RPM2::C::Header::_header_sprintf", XS_RPM2__C__Header__header_sprintf, file, "$$");
        newXSproto("RPM2::C::Transaction::DESTROY", XS_RPM2__C__Transaction_DESTROY, file, "$");
        newXSproto("RPM2::C::Transaction::_add_install", XS_RPM2__C__Transaction__add_install, file, "$$$$");
        newXSproto("RPM2::C::Transaction::_add_delete", XS_RPM2__C__Transaction__add_delete, file, "$$$");
        newXSproto("RPM2::C::Transaction::_element_count", XS_RPM2__C__Transaction__element_count, file, "$");
        newXSproto("RPM2::C::Transaction::_close_db", XS_RPM2__C__Transaction__close_db, file, "$");
        newXSproto("RPM2::C::Transaction::_check", XS_RPM2__C__Transaction__check, file, "$");
        newXSproto("RPM2::C::Transaction::_order", XS_RPM2__C__Transaction__order, file, "$");
        newXSproto("RPM2::C::Transaction::_elements", XS_RPM2__C__Transaction__elements, file, "$$");
        newXSproto("RPM2::C::Transaction::_run", XS_RPM2__C__Transaction__run, file, "$$$");

    /* Initialisation Section */

#line 175 "RPM2.xs"
    {
	HV *header_tags, *constants;
	rpmReadConfigFiles(NULL, NULL);

	header_tags = perl_get_hv("RPM2::header_tag_map", TRUE);
	_populate_header_tags(header_tags);

	constants = perl_get_hv("RPM2::constants", TRUE);

	/* not the 'standard' way of doing perl constants, but a lot easier to maintain */
#ifndef RPM2_RPM40
	REGISTER_CONSTANT(RPMVSF_DEFAULT);
	REGISTER_CONSTANT(RPMVSF_NOHDRCHK);
	REGISTER_CONSTANT(RPMVSF_NEEDPAYLOAD);
	REGISTER_CONSTANT(RPMVSF_NOSHA1HEADER);
	REGISTER_CONSTANT(RPMVSF_NOMD5HEADER);
	REGISTER_CONSTANT(RPMVSF_NODSAHEADER);
	REGISTER_CONSTANT(RPMVSF_NORSAHEADER);
	REGISTER_CONSTANT(RPMVSF_NOSHA1);
	REGISTER_CONSTANT(RPMVSF_NOMD5);
	REGISTER_CONSTANT(RPMVSF_NODSA);
	REGISTER_CONSTANT(RPMVSF_NORSA);
	REGISTER_CONSTANT(_RPMVSF_NODIGESTS);
	REGISTER_CONSTANT(_RPMVSF_NOSIGNATURES);
	REGISTER_CONSTANT(_RPMVSF_NOHEADER);
	REGISTER_CONSTANT(_RPMVSF_NOPAYLOAD);
	REGISTER_CONSTANT(TR_ADDED);
	REGISTER_CONSTANT(TR_REMOVED);
#endif
    }

#line 1220 "RPM2.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

